<!doctype html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <meta name="description" content="">
    <meta name="author" content="">
    <link rel="icon" href="img/favicon.ico">

    <title>P-Share Site Web</title>

    <!-- Bootstrap core CSS -->
    <link href="bootstrap-4.0.0-alpha.6/dist/css/bootstrap.min.css" rel="stylesheet">

    <!-- Custom styles for this template -->
    <link href="css/index.css" rel="stylesheet">
  </head>

  <body class="text-center">

    <div class="container d-flex h-100 p-3 mx-auto flex-column">
      <header class="mb-auto ml-auto ml-md-0 mr-auto mr-md-0">
        <nav class="nav navbar-toggleable-sm navbar-dark bg-dark">
          <a class="navbar-brand d-none d-md-inline-block">P-Share Site Web</a>
          <div class="navbar-nav">
            <a class="nav-item nav-link" href="index.html">Accueil</a>
            <a class="nav-item nav-link" href="objectifs.html">Objectifs</a>
            <a class="nav-item nav-link" href="cahier_charges.html">Cahier des charges</a>
            <a class="nav-item nav-link" href="presentation.html">Présentation</a>
            <a class="nav-item nav-link active" href="architecture.html">Architecture</a>
            <a class="nav-item nav-link" href="limites.html">Limites et améliorations</a>
          </div>
        </nav>
      </header>


      <main role="main" class="inner cover">
        <p class="lead text-justify">P-Share utilise de multiples technologies open-source interconnectées. Cela permet de faciliter la maintenabilité de la plateforme, pour peu que l'on apprenne à se servir de toutes ces technologies.<br>Nous avons déjà choisi de séparer le frontend du backend, ce qui nous donne plus de souplesse sur la conception des fonctionalités.<br>Nous avons également choisi de n'utiliser que du JavaScript pour faciliter la prise en main du projet par d'autres développeurs.</p>
        <ul class="lead text-justify">
          <li>frontend</li>
          <ul>
            <li><em>React JS</em>&nbsp;: un "framework" de Facebook chargé de l'affichage de composants dans le navigateur</li>
            <li><em>Redux</em>&nbsp;: un store chargé de gérer l'état de l'application</li>
            <li><em>Material UI</em>&nbsp;: un thème pour l'application (CSS)</li>
            <li><em>axios</em>&nbsp;: chargé de la communication entre le frontend et le backend</li>
          </ul>
          <li>backend</li>
          <ul>
            <li><em>express</em>&nbsp;: un serveur HTTP chargé des fonctionalités de l'application. Il se comporte comme une API associée à une session.</li>
            <li><em>serve</em>&nbsp;: un serveur HTTP statique chargé de la distribution des pages du frontend</li>
            <li><em>proxy</em>&nbsp;: route les requêtes vers l'API express ou vers le serveur statique (et gère le HTTPS). Ici, nous avons utilisé <em>traefik</em> en production et <em>http-proxy</em> en développement.</li>
            <li><em>redis</em>&nbsp;: un store chargé de la gestion "à l'échelle" des sessions utilisateur</li>
            <li><em>MariaDB</em>&nbsp;: un serveur sur le modèle de MySQL, chargé de la persistence des données</li>
          </ul>
        </ul>
        <img src="img/architecture.png" class="img-fluid" alt="P-Share architecture"/>
      </main>

      <footer class="mastfoot mt-auto">
        <div class="inner">
          <p>Réalisé par HIERNARD Stéphane, MISRAR Imane, WAUQUIER Elouan, DIEBOLD Aymerik.</p>
        </div>
      </footer>
    </div>


    <!-- Bootstrap core JavaScript
    ================================================== -->
    <!-- Placed at the end of the document so the pages load faster -->
    <script src="https://code.jquery.com/jquery-3.2.1.slim.min.js" integrity="sha384-KJ3o2DKtIkvYIK3UENzmM7KCkRr/rE9/Qpg6aAZGJwFDMVNA/GpGFF93hXpG5KkN" crossorigin="anonymous"></script>
    <script>window.jQuery || document.write('<script src="../../assets/js/vendor/jquery-slim.min.js"><\/script>')</script>
    <script src="bootstrap-4.0.0-alpha.6/dist/js/bootstrap.min.js"></script>
	<script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.14.7/umd/popper.min.js" integrity="sha384-UO2eT0CpHqdSJQ6hJty5KVphtPhzWj9WO1clHTMGa3JDZwrnQq4sF86dIHNDz0W1" crossorigin="anonymous"></script>
  </body>
</html>
